=== debian/changelog ===
bowtie2 (2.4.1-6) unstable; urgency=medium

  * Team upload.
  * Bump version requirement for libsimde-dev to grab ppc64el fixes.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 01 Jun 2020 15:40:38 +0200

bowtie2 (2.4.1-5) unstable; urgency=medium

  * Reproducible builds: filter out -ffile-prefix-map
    Closes: #961494

 -- Andreas Tille <tille@debian.org>  Mon, 25 May 2020 14:14:23 +0200

bowtie2 (2.4.1-4) unstable; urgency=medium

  * Team upload.
  * Switch to libsimde-dev package from our code copy

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 21 Apr 2020 15:35:11 +0200

bowtie2 (2.4.1-3) UNRELEASED; urgency=medium

  * Team upload.
  * Add salsa-ci file (routine-update)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 20 Apr 2020 17:54:38 +0200

bowtie2 (2.4.1-2) unstable; urgency=medium

  * Add patch fixing FTBFS with gcc10, thanks to Jun Aruga
    Closes: #957054

 -- Alexandre Mestiashvili <mestia@debian.org>  Sun, 19 Apr 2020 11:11:42 +0200

bowtie2 (2.4.1-1) unstable; urgency=medium

  * Team upload.
  * debian/control: not ready for 32-bit archs, and those builds often take
    2-3+ hours to fail, so lets be nice and skip them.
    Patches to fix 32-bit archs are very welcomed!
  * Standards-Version: 4.5.0 (routine-update)
  * Freshen patches
  * debian/upstream/metadata: Add Bug-{Database,Submit},Repository{,-Browse}
  * Update SIMDe version to 2a9ff6ddabfb940bdd29a0a0cd1ae3190f5fc97b 2020-04-03

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sun, 01 Mar 2020 11:30:50 +0100
