=== Makefile ===
--- 
+++ 
@@ -24,6 +24,7 @@
 PREFIX := /usr/local
 bindir := $(PREFIX)/bin
 
+ARCH := $(shell uname -m)
 LDLIBS := -lz
 GCC_PREFIX := $(shell dirname `which gcc`)
 GCC_SUFFIX :=
@@ -187,7 +188,7 @@
 BUILD_CPPS_MAIN := $(BUILD_CPPS) bowtie_build_main.cpp
 
 SEARCH_FRAGMENTS := $(wildcard search_*_phase*.c)
-VERSION := $(shell cat VERSION)
+VERSION := $(shell cat BOWTIE2_VERSION)
 
 SANITIZER_FLAGS :=
 ifeq (0,$(shell $(CXX) -E -fsanitize=address,undefined btypes.h > /dev/null 2>&1; echo $$?))
@@ -207,18 +208,18 @@
 else ifeq (aarch64,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
-  CPPFLAGS := -Ithird_party/simde
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party/simde
 else ifeq (s390x,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
-  CPPFLAGS := -Ithird_party/simde
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party/simde
   SANITIZER_FLAGS :=
 else ifeq (ppc64le,$(shell uname -m))
   BITS := 64
   SSE_FLAG :=
-  CXXFLAGS := -fopenmp-simd
+  CXXFLAGS += -fopenmp-simd
   CPPFLAGS += -Ithird_party/simde
   SANITIZER_FLAGS :=
 endif
@@ -282,7 +283,7 @@
   MANUAL.markdown \
   README.md \
   TUTORIAL \
-  VERSION
+  BOWTIE2_VERSION
 
 ifeq (1,$(WINDOWS))
   BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
@@ -321,8 +322,8 @@
 both-sanitized: bowtie2-align-s-sanitized bowtie2-build-s-sanitized bowtie2-align-l-sanitized bowtie2-build-l-sanitized ;
 
 DEFS := -fno-strict-aliasing \
-  -DBOWTIE2_VERSION="\"`cat VERSION`\"" \
-  -DBUILD_HOST="\"${HOSTNAME:-`hostname`}\"" \
+  -DBOWTIE2_VERSION="\"`cat BOWTIE2_VERSION`\"" \
+  -DBUILD_HOST="\"$${HOSTNAME:-`hostname`}\"" \
   -DBUILD_TIME="\"`date -u`\"" \
   -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
   $(FILE_FLAGS) \
@@ -419,7 +420,7 @@
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
@@ -428,7 +429,7 @@
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
@@ -437,7 +438,7 @@
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(CXXFLAGS) \
 		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) -I . \
+		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
