=== debian/changelog ===
bowtie2 (2.4.2-2) unstable; urgency=medium

  [ Vagrant Cascadian ]
  * Patch Makefile to set date for BUILD_TIME using SOURCE_DATE_EPOCH.
    Closes: #977435
  * Force same hostname to enable reproducible builds
    Closes: #977436

  [ Andreas Tille ]
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * use binaries installed to debian/tmp

 -- Andreas Tille <tille@debian.org>  Tue, 15 Dec 2020 21:07:56 +0100

bowtie2 (2.4.2-1) unstable; urgency=medium

  * New upstream version 2.4.2
  * Refresh patches,
    drop applied by upstream gcc10_ftbfs_invalid_dquote_char.patch
  * Apply cme fix dpkg, drop version from libsimde-dev

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 07 Oct 2020 20:06:52 +0200
