=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
            Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                help2man,
                libtbb-dev,
                python3,
@@ -13,22 +13,21 @@
                libclone-perl,
                libfile-which-perl,
                zlib1g-dev,
-               libsimde-dev (>= 0.0.0.git.20200526)
-Standards-Version: 4.5.0
-Rules-Requires-Root: no
+               libsimde-dev
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: http://bowtie-bio.sourceforge.net/bowtie2
+Rules-Requires-Root: no
 
 Package: bowtie2
 Architecture: any-amd64 arm64 mips64el ppc64el s390x ia64 m68k ppc64 riscv64 sh4 sparc64
-# "any-64bit" :-)
-Built-Using: ${simde:Built-Using}
 Depends: python3,
          ${misc:Depends},
          ${shlibs:Depends},
          ${perl:Depends}
 Suggests: bowtie2-examples
+Built-Using: ${simde:Built-Using}
 Description: ultrafast memory-efficient short read aligner
  is an ultrafast and memory-efficient tool for aligning sequencing reads
  to long reference sequences. It is particularly good at aligning reads
