=== debian/rules ===
--- 
+++ 
@@ -24,7 +24,7 @@
 	dh $@
 
 override_dh_auto_build:
-	LD_PRELOAD= dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS)
+	LD_PRELOAD= dh_auto_build -- EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) HOSTNAME=reproducible-hostname
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
