=== debian/tests/control ===
Tests: check-wo-arguments

Tests: indexing-ref-genome

Tests: binary-run
