=== debian/watch ===
version=4

https://github.com/BenLangmead/bowtie2/releases .*/archive/v(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
