=== Makefile ===
--- 
+++ 
@@ -24,18 +24,15 @@
 PREFIX := /usr/local
 bindir := $(PREFIX)/bin
 
-ARCH := $(shell uname -m)
-LDLIBS := -lz
-GCC_PREFIX := $(shell dirname `which gcc`)
-GCC_SUFFIX :=
-CC ?= $(GCC_PREFIX)/gcc$(GCC_SUFFIX)
-CPP ?= $(GCC_PREFIX)/g++$(GCC_SUFFIX)
-CXX ?= $(CPP)
+LDLIBS := -lpthread -lz
 
 HEADERS := $(wildcard *.h)
 BOWTIE_MM := 1
 BOWTIE_SHARED_MEM :=
 
+CXXFLAGS += -std=c++11
+
+ARCH = $(shell uname -m)
 NGS_VER ?= 2.9.2
 VDB_VER ?= 2.9.2-1
 
@@ -61,12 +58,34 @@
   endif
 endif
 
+BITS := 32
+ifneq (,$(findstring $(shell uname -m), x86_64 amd64))
+  BITS := 64
+  SSE_FLAG := -msse2
+  POPCNT_CAPABILITY ?= 1
+else ifneq (,$(findstring $(shell uname -m), aarch64 arm64 s390x ppc64 ppc64le))
+  BITS := 64
+  SSE_FLAG :=
+  CXXFLAGS += -fopenmp-simd
+  CPPFLAGS += -Ithird_party
+  POPCNT_CAPABILITY ?= 0
+endif
+
+# msys will always be 32 bit so look at the cpu arch instead.
+ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
+  ifeq (1,$(MINGW))
+    BITS := 64
+  endif
+endif
+ifeq (32,$(BITS))
+  $(error bowtie2 compilation requires a 64-bit platform )
+endif
+
 ifdef STATIC_BUILD
   LDFLAGS += -L$(CURDIR)/.tmp/lib
   CPPFLAGS += -I$(CURDIR)/.tmp/include
 endif
 
-POPCNT_CAPABILITY ?= 1
 ifeq (1, $(POPCNT_CAPABILITY))
   CXXFLAGS += -DPOPCNT_CAPABILITY
   CPPFLAGS += -I third_party
@@ -86,11 +105,6 @@
 
 PTHREAD_PKG :=
 PTHREAD_LIB :=
-
-#if we're not using TBB, then we can't use queuing locks
-ifeq (1,$(NO_TBB))
-  NO_QUEUELOCK := 1
-endif
 
 ifeq (1,$(MINGW))
   PTHREAD_LIB :=
@@ -100,22 +114,6 @@
 
 ifeq (1,$(NO_SPINLOCK))
   CXXFLAGS += -DNO_SPINLOCK
-endif
-
-#default is to use Intel TBB
-ifneq (1,$(NO_TBB))
-  LDLIBS += $(PTHREAD_LIB) -ltbb
-  ifdef STATIC_BUILD
-    LDLIBS += -ltbbmalloc
-    ifndef MINGW
-      LDLIBS += -ldl
-    endif
-  else
-    LDLIBS += -ltbbmalloc_proxy
-  endif
-  CXXFLAGS += -DWITH_TBB -std=c++11
-else
-  LDLIBS += $(PTHREAD_LIB)
 endif
 
 USE_SRA ?=
@@ -143,20 +141,16 @@
   CXXFLAGS += -DWITH_AFFINITY=1
 endif
 
-#default is to use Intel TBB's queuing lock for better thread scaling performance
+#default is to use queue lock for better thread scaling performance
 ifneq (1,$(NO_QUEUELOCK))
   CXXFLAGS += -DNO_SPINLOCK
   CXXFLAGS += -DWITH_QUEUELOCK=1
 endif
 
 SHARED_CPPS :=  ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
-  edit.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
+  edit.cpp bt2_locks.cpp bt2_idx.cpp bt2_io.cpp bt2_util.cpp \
   reference.cpp ds.cpp multikey_qsort.cpp limit.cpp \
   random_source.cpp
-
-ifeq (1,$(NO_TBB))
-  SHARED_CPPS += tinythread.cpp
-endif
 
 SEARCH_CPPS :=  qual.cpp pat.cpp sam.cpp \
   read_qseq.cpp aligner_seed_policy.cpp \
@@ -177,6 +171,11 @@
   aligner_swsse_ee_u8.cpp \
   aligner_driver.cpp
 
+ifeq (1, $(WITH_ZSTD))
+  LDLIBS += -lzstd
+  SHARED_CPPS += zstd_decompress.cpp
+endif
+
 SEARCH_CPPS_MAIN := $(SEARCH_CPPS) bowtie_main.cpp
 
 DP_CPPS := qual.cpp aligner_sw.cpp aligner_result.cpp ref_coord.cpp mask.cpp \
@@ -197,40 +196,6 @@
   SANITIZER_FLAGS := -fsanitize=address
 else ifeq (0,$(shell $(CXX) -E -fsanitize=undefined btypes.h > /dev/null 2>&1; echo $$?))
   SANITIZER_FLAGS := -fsanitize=undefined
-endif
-
-BITS := 32
-SSE_FLAG := -msse2
-ifeq (x86_64,$(shell uname -m))
-  BITS := 64
-else ifeq (amd64,$(shell uname -m))
-  BITS := 64
-else ifeq (aarch64,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-else ifeq (s390x,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-  SANITIZER_FLAGS :=
-else ifeq (ppc64le,$(shell uname -m))
-  BITS := 64
-  SSE_FLAG :=
-  CXXFLAGS += -fopenmp-simd
-  CPPFLAGS += -Ithird_party/simde
-  SANITIZER_FLAGS :=
-endif
-# msys will always be 32 bit so look at the cpu arch instead.
-ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
-  ifeq (1,$(MINGW))
-    BITS := 64
-  endif
-endif
-ifeq (32,$(BITS))
-  $(error bowtie2 compilation requires a 64-bit platform )
 endif
 
 DEBUG_FLAGS    := -O0 -g3 $(SSE_FLAG)
@@ -287,11 +252,7 @@
 
 ifeq (1,$(WINDOWS))
   BOWTIE2_BIN_LIST := $(BOWTIE2_BIN_LIST) bowtie2.bat bowtie2-build.bat bowtie2-inspect.bat
-  ifneq (1,$(NO_TBB))
-    CXXFLAGS += -static-libgcc -static-libstdc++
-  else
-    CXXFLAGS += -static -static-libgcc -static-libstdc++
-  endif
+  CXXFLAGS += -static-libgcc -static-libstdc++
 endif
 
 # This is helpful on Windows under MinGW/MSYS, where Make might go for
@@ -443,3 +404,36 @@
 		$(SHARED_CPPS) \
 		$(LDFLAGS) $(LDLIBS)
 
+bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(CXXFLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+#
+# bowtie2-dp targets
+#
+
+bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(RELEASE_FLAGS) \
+		$(RELEASE_DEFS) $(CXXFLAGS) $(NOASSERT_FLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+bowtie2-dp-debug: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
+	$(CXX) $(DEBUG_FLAGS) \
+		$(DEBUG_DEFS) $(CXXFLAGS) \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
+		$(CPPFLAGS) \
+		-o $@ $< \
+		$(DP_CPPS) $(SHARED_CPPS) \
+		$(LDFLAGS) $(LDLIBS)
+
+bowtie2.bat:
+	echo "@echo off" > bowtie2.bat
