=== debian/changelog ===
bowtie2 (2.4.4-1) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Refresh patches

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 13 Sep 2021 18:45:11 +0200
