=== debian/watch ===
version=4

https://github.com/BenLangmead/bowtie2/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
