=== debian/changelog ===
bowtie2 (2.4.5-1) unstable; urgency=medium

  * New upstream version
  * Drop transition for old debug package migration.

 -- Andreas Tille <tille@debian.org>  Thu, 17 Feb 2022 16:46:58 +0100
