=== debian/rules ===
--- 
+++ 
@@ -38,9 +38,6 @@
 	LD_PRELOAD= make -j1 test
 endif
 
-override_dh_auto_install:
-	dh_auto_install
-
 override_dh_install:
 	dh_install -X.gitignore
